// Class_Event.prg
#USING System.Data
#USING System.Data.OLEDB
#USING System.Net
#USING System.Net.Mail
Class MIMEvent
    Protect oConn       as OLEDBConnection
    Protect cConnStr    as String
    protect cFullName   as string
    protect cID         as string
    protect cAddr1      as string
    protect cAddr2      as string
    protect cCity       as string
    protect cState      as string
    protect cPostal     as string
    protect cPhone      as string
    protect cEmail      as string
    protect cDogName    as string
    protect cDogAge     as string
    protect cDogBreed   as string
    protect nAmt        as decimal
    protect cPmt        as string
    protect dEventDate  as datetime
    protect cConfNum    as string

    protect SubmitDate  as string
    
CONSTRUCTOR()
    RETURN
Method Echo(msg as string) as string
    return msg    
METHOD OpenConnection() as string
    local cResult   as string
    try
        if self:oConn == NULL
            SELF:oConn  := OleDbConnection{self:cConnStr}
            self:oConn:Open()
        endif
        cResult := ""
    catch e as System.Exception
        cResult := e:Message
    end try
    return cResult
Method WriteTempRegistration() as string
    local cResult       as string
    local cSQL          as string
    local oCmd          As OleDbCommand

    try
        
        cResult := self:OpenConnection()
        if !empty(cResult)
            throw ApplicationException{"Error Opening Connection"} 
        endif
        // get the timestamp
        SELF:SubmitDate := DateTime.Now:ToString()
        
        // build the SQL to write the record
        cSQL := "insert into PendingRegistration (eventID,name,addr1,addr2,city,state,zip,phone,email,dogname,dogage,dogbreed,amt,SystemTS)"
        cSQL += " Values ("
        cSQL += " " + ConstClass.SQLString(self:cID)
        cSQL += ", '" + ConstClass.SQLString(self:cfullname) + "'"
        cSQL += ", '" + ConstClass.SQLString(self:caddr1) + "'"
        cSQL += ", '" + ConstClass.SQLString(self:caddr2) + "'"
        cSQL += ", '" + ConstClass.SQLString(self:cCity) + "'"
        cSQL += ", '" + ConstClass.SQLString(self:cState) + "'"
        cSQL += ", '" + ConstClass.SQLString(self:cpostal) + "'"
        cSQL += ", '" + ConstClass.SQLString(self:cphone) + "'"
        cSQL += ", '" + ConstClass.SQLString(self:cEmail) + "'"
        cSQL += ", '" + ConstClass.SQLString(self:cdogname) + "'"
        cSQL += ", '" + ConstClass.SQLString(self:cdogage) + "'"
        cSQL += ", '" + ConstClass.SQLString(self:cdogbreed) + "'"
        cSQL += ", " + self:nAmt:ToString()
        cSQL += ", #" + SubmitDate + "#"
        cSQL += " )"
    
    
        oCmd                := OleDbCommand{}
        oCmd:Connection     := self:oConn
        oCmd:CommandText    := cSQL
        oCmd:CommandTimeout := 300
        oCmd:ExecuteNonQuery()  // executes the command without a return value

        cResult         := ""
    catch e as System.Exception
        cResult := e:Message
    end try
    RETURN cResult


Method GetEventCost(nAmt ref decimal, EventDate ref datetime) as string
    local cResult   as string
    local cSQL      as string
    local oCmd      As OleDbCommand
    local oRS       As OleDbDataReader
    
    try
        cResult := self:OpenConnection()
        if !empty(cResult)
            throw ApplicationException{"Error Opening Connection"} 
        endif
        oCmd                := OleDbCommand{}
        oCmd:Connection     := self:oConn
        

        // now reaad the event cost
        cSQL := "Select EventCost,EventDate from Events where"
        cSQL += " EventID = " + self:cID
            
        // send a new query, this time returning a datareader
        oCmd:CommandText    := cSQL
        oCmd:CommandTimeout := 300
	        
        oRS := oCmd:ExecuteReader()
        // now read the data
        oRS:Read()
        nAmt := (decimal)oRS:item["EventCost"]
        EventDate := (datetime)oRS:item["EventDate"]
        
        oRS:Close()


        cResult         := ""
    catch e as System.Exception
        cResult := e:Message
    end try
        
    Return cResult    
    
Method GetConfirmationNumber(cConfNum ref String) as string
    local cResult   as string
    local cSQL      as string
    local oCmd      As OleDbCommand
    local oRS       As OleDbDataReader
    
    try
        cResult := self:OpenConnection()
        if !empty(cResult)
            throw ApplicationException{"Error Opening Connection"} 
        endif
        oCmd                := OleDbCommand{}
        oCmd:Connection     := self:oConn
        
        // executes the command without a return value
        // retrieve the newly created confirmation number from the DB
        cSQL := "Select ConfNum from PendingRegistration where"
        cSQL += " name = '" + ConstClass.SQLString(self:cFullname) + "' and "
        cSQL += " dogname = '" + ConstClass.SQLString(self:cdogname) + "'"
        cSQL += " and EventID = " + self:cID
        cSQL += " and SystemTS = #" + self:SubmitDate + "#"
            
        // send a new query, this time returning a datareader
        oCmd:CommandText    := cSQL
        oCmd:CommandTimeout := 300
	        
        oRS := oCmd:ExecuteReader()
        // now read the data
        oRS:Read()
        cConfNum := oRS:item["confnum"]:ToString()
        oRS:Close()


        cResult         := ""
    catch e as System.Exception
        cResult := e:Message
    end try
        
    Return cResult    
Method MoveConfNumIntoProduction(ConfNum as string) as string
    local cResult   as string
    local cSQL      as string
    local oCmd      As OleDbCommand
    local oRS       As OleDbDataReader
    
    try
        self:cConfNum   := confnum
        cResult := self:OpenConnection()
        if !empty(cResult)
            throw ApplicationException{"Error Opening Connection"} 
        endif
        oCmd                := OleDbCommand{}
        oCmd:Connection     := self:oConn
        
        cSQL := "insert into Registration "
        cSQL += " select * from PendingRegistration where"
        cSQL += " confnum = " + self:cConfNum
        
        // set out command up
        oCmd:CommandText    := cSQL
        oCmd:CommandTimeout := 300
        oCmd:ExecuteNonQuery()  // executes the command without a return value

        cSQL := "delete from PendingRegistration "
        cSQL += " where"
        cSQL += " confnum = " + self:cConfnum
        
        // set out command up
        oCmd:CommandText    := cSQL
        oCmd:CommandTimeout := 300
        oCmd:ExecuteNonQuery()  // executes the command without a return value

        // update the payment type and amount. The amount will be different
        // between credit card and cash
        cSQL := "Update Registration "
        cSQL += " Set PaymentBy = '" + self:cPmt + "'"
        cSQL += " ,amt = " + self:nAmt:ToString()
        cSQL += " where confnum = " + self:cConfnum
        
        // set out command up
        oCmd:CommandText    := cSQL
        oCmd:CommandTimeout := 300
        oCmd:ExecuteNonQuery()  // executes the command without a return value

        // read in all of the registration table so I can send emails
        cSQL := "Select r.*,e.EventDate from Registration r, Events e"
        cSQL += " where r.EventID = e.EventID"
        cSQL += " and confnum = " + self:cConfnum
        
        // set out command up
        oCmd:CommandText    := cSQL
        oCmd:CommandTimeout := 300
        oRS := oCmd:ExecuteReader()

        // read in out ivars
        oRS:Read()
        self:cState     := oRS:item["State"]:toString()
        self:cFullname  := oRS:item["Name"]:toString()
        self:caddr1     := oRS:item["addr1"]:toString()
        self:caddr2     := oRS:item["addr2"]:toString()
        self:cCity      := oRS:item["city"]:toString()
        self:cDogname   := oRS:item["dogname"]:toString()
        self:cDogage    := oRS:item["dogage"]:toString()
        self:cDogbreed  := oRS:item["dogbreed"]:toString()
        self:cPostal    := oRS:item["zip"]:toString()
        self:cPhone     := oRS:item["phone"]:toString()
        self:cEmail     := oRS:item["email"]:toString()
        self:cId        := oRS:item["EventID"]:toString()
        self:dEventDate := (datetime)oRS:item["EventDate"]
        
        oRS:Close()
        

        cResult         := ""
    catch e as System.Exception
        cResult := e:Message
    end try
        
    Return cResult 
method sendEmails() as void
    local body      as string
    LOCAL mm 		AS MailMessage
    LOCAL smtp 		AS SmtpClient

    try            
            // send an email saying that there is a new member
            body := ""
            body += Chrw(13) + Chr(10) + "          Event Date : " + self:dEventDate:ToString("D")
            body += Chrw(13) + Chr(10) + "                Name : " + self:cfullname
            body += Chrw(13) + Chr(10) + "             Address : " + self:caddr1
            body += Chrw(13) + Chr(10) + "                     : " + self:caddr2
            body += Chrw(13) + Chr(10) + "                City : " + self:cCity
            body += Chrw(13) + Chr(10) + "               State : " + self:cstate
            body += Chrw(13) + Chr(10) + "                 Zip : " + self:cpostal
            body += Chrw(13) + Chr(10) + "               Phone : " + self:cphone
            body += Chrw(13) + Chr(10) + "          Email Addr : " + self:cEmail
            body += Chrw(13) + Chr(10) + "          Dog's Name : " + self:cdogname
            body += Chrw(13) + Chr(10) + "           Dog's Age : " + self:cdogage
            body += Chrw(13) + Chr(10) + "         Dog's Breed : " + self:cdogbreed
            body += Chrw(13) + Chr(10) + "        Payment Type : " + self:cpmt
            body += Chrw(13) + Chr(10) + "          Amount Due : " + self:namt:tostring()
            body += Chrw(13) + Chr(10) + "Confirmation Number  : " + self:cConfnum
            body += Chrw(13) + Chr(10) + "           Date/Time : " + datetime.Now:tostring()
	        
            // build the mail message
            mm          := MailMessage{}
            mm:From     := MailAddress{"herding@mannersinmotion.com", "Willie Moore"}
            mm:@@To:Add("YOUR_ADDRESS_HERE@YOURDOMAIN")
 //           mm:@@To:Add("wcm469@yahoo.com")
 //           mm:CC:Add("YOUR_CC_ADDRESSHERE@YOUR_CC_DOMAIN")
            mm:Subject  := "New member payment info from HerdingRegister/after_create.asp"
          
            mm:Body     := body
	
            // initialize the server
            smtp                := SmtpClient{}
            smtp:Credentials    := NetworkCredential{"Your Email Address goes here", "Your Password Goes Here"}
            smtp:Send(mm)

            If !empty(SELF:cEMail)
                body := "Hello " + self:cfullname
                body += Chrw(13) + Chrw(10) + "Thank you for registering for the Herding Seminar."
                body += Chrw(13) + Chrw(10) + "We look forward to seeing you on " + self:dEventDate:ToString("D") + "."
                body += Chrw(13) + Chrw(10) + ""
                body += Chrw(13) + Chrw(10) + "As a reminder, we will start at 8:00am."
                body += Chrw(13) + Chrw(10) + " Please remember your sunscreen, a hat, chair, and of course your dog, crate and leash"
                body += Chrw(13) + Chrw(10) + ""
                body += Chrw(13) + Chrw(10) + "Your confirmation number is:" + self:cConfnum
                body += Chrw(13) + Chrw(10) + ""
                body += Chrw(13) + Chrw(10) + "Thanks again!"
                body += Chrw(13) + Chrw(10) + "Manners in Motion"

                mm          := MailMessage{}
                mm:From     := MailAddress{"YOUR_ADDRESS_HERE", "YOUR_NAME_GOES_HERE"}
                mm:@@To:Add(self:cEMail)
                mm:Subject  := "Confirmation Email for Herding Seminar"
                mm:Body     := body

                smtp:Credentials := NetworkCredential{"Your Email Address goes here", "Your Password Goes Here"}
                smtp:Send(mm)
            ENDIF
    catch e as System.Exception
    END TRY
    RETURN       


    access FullName   as string
        return SELF:cFullName
    access ID         as string
        return self:cID        
    access Addr1      as string
        return self:cAddr1
    access Addr2      as string
        return self:cAddr2
    access City       as string
        return self:cCity
    access State      as string
        return self:cState
    access Postal     as string
        return self:cPostal
    access Phone      as string
        return self:cPhone
    access Email      as string
        return self:cEmail
    access DogName    as string
        return self:cDogName
    access DogAge     as string
        return self:cDogAge
    access DogBreed   as string
        return self:cDogBreed
    access Amt        as decimal
        return self:nAmt
    access Pmt        as string
        return self:cPmt
    access EventDate  as datetime
        return self:dEventDate
    access ConfNum    as string
        return self:cConfNum

    assign FullName(cVar as string)   as void
        SELF:cFullName := cVar
        return
    assign ID(cVar as string)         as void
        self:cID    := cVar
        return
    assign Addr1(cVar as string)      as void
        self:cAddr1 := cVar
        return
    assign Addr2(cVar as string)      as void
        self:cAddr2 := cVar
        return
    assign City(cVar as string)       as void
        self:cCity := cVar
        return
    assign State(cVar as string)      as void
        self:cState := cVar
        return
    assign Postal(cVar as string)     as void
        self:cPostal := cVar
        return
    assign Phone(cVar as string)      as void
        self:cPhone := cVar
        return
    assign Email(cVar as string)      as void
        self:cEmail := cVar
        return
    assign DogName(cVar as string)    as void
        self:cDogName   := cVar
        return
    assign DogAge(cVar as string)     as void
        self:cDogage := cVar
        return
    assign DogBreed(cVar as string)   as void
        self:cDogBreed := cVar
        return
    assign Amt(nVar as decimal)       as void
        self:nAmt := nVar
        return
    assign ConnStr(cVar as string)    as void
        self:cConnStr := cVar
        return        
    assign Pmt(cVar as string)        as void
        self:cPmt   := cVar
        return        
    assign EventDate(dVar as datetime)  as void
        self:dEventDate := dVar
        return
    assign ConfNum(cVar as string)      as void
        self:cConfNum   := cVar
        return
    
END CLASS