#USING System.Drawing
#USING System.Web.UI    
#USING System.Web.UI.WebControls 
#USING System.Data
#USING System.Data.OleDb
#USING System.Collections
#USING System.Configuration
#USING Microsoft.VisualBasic
#USING wmConsulting.MannersinMotion

CLASS WebForm1 INHERIT Page
	PROTECT NomeTextBox     AS TextBox   
	PROTECT PwdTextBox      AS TextBox
	PROTECT Label1          AS Label    
	PROTECT Label2          AS Label
	PROTECT TitoloLabel     AS Label
	PROTECT NomeLabel       AS Label
	PROTECT InviaButton     AS Button
	PROTECT TransferButton  AS Button
    PROTECT Avviso		    AS Label
CONSTRUCTOR()  
	SUPER()  
	
RETURN      

METHOD Page_Load(Sender AS OBJECT, e AS EventArgs) AS VOID    
	
	SELF:TitoloLabel:Text := "Connect to Server on "+DToC(Today())+" "+Time()
	SELF:TitoloLabel:BackColor := Color.White
	SELF:TitoloLabel:ForeColor := Color.Blue
	SELF:TitoloLabel:Font:Bold := TRUE
	SELF:TitoloLabel:Font:Size := 20
	
	SELF:Label1:Text := "User Name"  
	SELF:Label2:Text := "Password"
	SELF:InviaButton:Text := "Connect"   
	SELF:TransferButton:Text := "Next Page"   
	
	SELF:PwdTextBox:TextMode := TextBoxMode.Password
	SELF:NomeLabel:Text := "" 
	SELF:Avviso:Text := ""
RETURN 	                                                   

METHOD InviaButton_Click(Sender AS OBJECT, e AS EventArgs) AS VOID
	SELF:NomeLabel:Text := "No Connection Available"	
RETURN 
METHOD TransferButton_Click(Sender AS OBJECT, e AS EventArgs) AS VOID
	Server:Transfer("NewPage.ASPX")
RETURN 
		
END CLASS

CLASS WebForm2 INHERIT Page
	PROTECT txtTitle AS Label
CONSTRUCTOR()  
	SUPER()  
	
RETURN      

METHOD Page_Load(Sender AS OBJECT, e AS EventArgs) AS VOID    
	
	SELF:txtTitle:Text := "Made it to the 2nd page : "+DToC(Today())+" "+Time()
	
RETURN 	                                                   
end class

CLASS frmEvents INHERIT Page
	PROTECT HeadingMsg          AS Label   
	protect EventsGrid          AS DataGrid
CONSTRUCTOR()  
	SUPER()  	
    RETURN   
METHOD Page_Load(Sender AS OBJECT, e AS EventArgs) AS VOID    
    SELF:HeadingMsg:Text := "Upcoming Events at Manners in Motion"
    IF !IsPostback
        SELF:EventsGrid:Datasource := FillGrid()
        SELF:EventsGrid:DataBind()
    ENDIF
    RETURN
METHOD Grid_Change(sender As Object, e As DataGridPageChangedEventArgs) as VOID
        SELF:EventsGrid:CurrentPageIndex := e:NewPageIndex
        SELF:EventsGrid:DataBind()
    RETURN 
    
METHOD FillGrid() As ICollection
        LOCAL connStr           As String
        LOCAL conn              As OleDbConnection
    
        LOCAL cSQL              As String
        LOCAL adapter           As OleDbDataAdapter
        LOCAL oDS               As DataSet
        LOCAL title_col         As BoundColumn
        LOCAL date_col          As BoundColumn
        LOCAL loc_col           As BoundColumn
        LOCAL description_col   As BoundColumn
        LOCAL Cost_col          As BoundColumn
        LOCAL Info_col          As ButtonColumn

        // put the user into the database
        connStr := System.Configuration.ConfigurationManager.AppSettings["DSN"]
        conn    := OleDbConnection{connStr}
        conn:Open()
        
        cSQL := "select * from Events"
        cSQL += " Order by EventDate Desc"
        
        oDS     := DataSet{}
        adapter := OleDbDataAdapter{}
        adapter:SelectCommand := OleDbCommand{cSQL, conn}
        adapter:Fill(oDS)

        // Add out columns
        title_col               := BoundColumn{}
        title_col:DataField     := "EventTitle"
        title_col:HeaderText    := "Event"
        SELF:EventsGrid:Columns:Add(title_col)

        date_col                    := BoundColumn{}
        date_col:DataField          := "EventDate"
        date_col:HeaderText         := "Date"
        date_col:DataFormatString   := "{0:MM-dd-yyyy}"
        SELF:EventsGrid:Columns:Add(date_col)

        loc_col             := BoundColumn{}
        loc_col:DataField   := "EventLocation"
        loc_col:HeaderText  := "Loction"
        SELF:EventsGrid:Columns:Add(loc_col)

        description_col                 := BoundColumn{}
        description_col:DataField       := "EventDescription"
        description_col:HeaderText      := "Description"
        description_col:ItemStyle:Width := 250
        description_col:ItemStyle:Wrap  := TRUE
        SELF:EventsGrid:Columns:Add(description_col)

        Cost_col                    := BoundColumn{}
        Cost_col:DataField          := "EventCost"
        Cost_col:HeaderText         := "Cost"
        Cost_col:DataFormatString   := "{0:c}"
        SELF:EventsGrid:Columns:Add(Cost_col)

        Info_col                := ButtonColumn{}
        Info_col:DataTextField  := "EventOpen"
        Info_col:ButtonType     := ButtonColumnType.LinkButton
        Info_col:CommandName    := "cancel"
        Info_col:HeaderText     := " "
        SELF:EventsGrid:Columns:Add(Info_col)
        
        Return oDS:Tables[0]:DefaultView

Method Item_Bound(sender As Object, e As DataGridItemEventArgs) AS VOID
        LOCAL item          As DataGridItem
        LOCAL rv            As DataRowView
        LOCAL b             As HyperLink
        LOCAL cUrl          As String
        LOCAL cEventID      As String
        LOCAL EventDate     As System.DateTime
        
        item := e:Item
        If item:ItemType == ListItemType.AlternatingItem .or. item:ItemType == ListItemType.Item
            rv := (DataRowView)item:DataItem
            If (logic)rv:Row:Item["EventOpen"] == False 
                item:Cells[5]:Visible := False
            Else
                cEventID        := rv:Row:Item["EventID"]:ToString()
                EventDate       := (datetime)rv:Row:Item["EventDate"]
                cUrl := (string)rv:Row:Item["EventUrl"] + ".aspx?EventID=" + cEventID + "&EventDate=" + Server:HtmlEncode(EventDate:ToString())
                cUrl += "&EventLoc=" + Server:HtmlEncode((string)rv:Row:Item["EventLocation"])
                cUrl += "&EventCost=" + Server:HtmlEncode((string)rv:Row:Item["EventCost"]:ToString())
                cUrl += "&Eventtime=" + Server:HtmlEncode((string)rv:Row:Item["EventStartTime"])
                b               := HyperLink{}
                b:ID            := "BtnClick"
                b:Text          := "Open"
                b:NavigateUrl   := cUrl
                b:Enabled       := True
                item:Cells[5]:Controls:RemoveAt(0)
                item:Cells[5]:Controls:Add(b)
            EndIF
        EndIf

    RETURN   
END CLASS
CLASS frmHerdingWithWendy INHERIT frmEventBase
    PROTECT txtEventDate        AS LABEL
    PROTECT txtEventLocation    AS LABEL
    PROTECT txtEventCost        AS Label
    PROTECT txtStartTime        AS Label
CONSTRUCTOR()  
	SUPER()  	
    RETURN   
METHOD Page_Load(Sender AS OBJECT, e AS EventArgs) AS VOID    
    LOCAL ID            As String
    LOCAL EventDate     As String
    LOCAL EventCost     As String
    LOCAL EventLocation As String
    LOCAL EventStart    As String
    
    //get the variables as passed by the web site
    ID := Request["EventID"]
    EventDate := Request["EventDate"]
    EventCost := Request["EventCost"]
    EventLocation := Request["EventLoc"]
    EventStart := Request["Eventtime"]
               
    SELF:txtEventID:value         := ID
    SELF:txtEventDate:Text        := EventDate:Substring(0,10)
    SELF:txtEventLocation:Text    := EventLocation
    SELF:txtEventCost:Text        := EventCost // Microsoft.VisualBasic.Strings.FormatCurrency(EventCost:ToObject())
    SELF:txtStarttime:Text        := EventStart

    SELF:HeadingMsg:Text := "Herding with Wendy Roller"
    RETURN
    
Protected Method btnSubmit_Click(sender As Object, e As System.EventArgs) AS VOID
        If Page:IsValid
            Response:Redirect("HerdingRegister.aspx?eventid=" + SELF:txtEventID:value)
        End If
    RETURN

END CLASS
CLASS frmHerdingRegister INHERIT frmEventBase
CONSTRUCTOR()  
	SUPER()  	
    RETURN   
METHOD Page_Load(Sender AS OBJECT, e AS EventArgs) AS VOID    
    LOCAL cMsg      As String
    LOCAL connStr   As String
    LOCAL state     As String
    LOCAL country   As String
    LOCAL fullname  As String
    LOCAL addr      As String
    LOCAL addr2     As String
    LOCAL cit       As String
    LOCAL postal    As String
    LOCAL phone     As String
    LOCAL eml       As String
    LOCAL dogname   As String
    LOCAL dogage    As String
    LOCAL dogbreed  As String
    LOCAL ID        As String


    //get the variables as passed by the web site
    If !Page:IsPostBack
            connStr     := System.Configuration.ConfigurationManager.AppSettings["DSN"]
            
            country     := (string)Request["country"]
            state       := (string)Request["state"]
            fullname    := (string)Request["fullname"]
            addr        := (string)Request["address"]
            addr2       := (string)Request["address2"]
            cit         := (string)Request["city"]
            postal      := (string)Request["zip"]
            phone       := (string)Request["phone"]
            eml         := (string)Request["email"]
            dogname     := (string)Request["dogname"]
            dogage      := (string)Request["dogage"]
            dogbreed    := (string)Request["dogbreed"]
            ID          := (string)Request["eventid"]

            // set the country to US and State to AL as the default
            If empty(country)
                country := "US"
                state   := "AL"
            End If
        
            // Assign the values to the textboxes
            SELF:txtcountry:Value       := country
            SELF:txtfullname:Text       := fullname
            SELF:txtState:Text          := state
            SELF:txtaddress:Text        := addr
            SELF:txtaddress2:Text       := addr2
            SELF:txtcity:Text           := cit
            SELF:txtzip:Text            := postal
            SELF:CountryLabel:Text      := country
            SELF:txtcountry:Value       := country
            SELF:txtEventID:Value       := ID
            SELF:txtphone:Text          := phone
            SELF:txtemail:Text          := eml
            SELF:txtdogname:Text        := dogname
            SELF:txtdogage:Text         := dogage
            SELF:txtdogbreed:Text       := dogbreed
            SELF:msg:Text               := ""
            SELF:msg:Visible            := False
            SELF:Page:SetFocus(SELF:txtfullname)

            
            // set any message that may have been passed into the form
            cMsg := Request["msg"]
            If !empty(cMsg)
                SELF:msg:Text       := cMsg
                SELF:msg:Font:Size  := 14
                SELF:msg:ForeColor  := Drawing.Color.Red
                SELF:msg:Visible    := True
            End If    
    END IF

    SELF:HeadingMsg:Text := "Event Registration Form"
    RETURN
    
Protected Method btnSubmit_Click(sender As Object, e As System.EventArgs) AS VOID
        If Page:IsValid
            // set the variables that I will be passing to the next form
            Context:Items["country"]    := SELF:txtcountry:Value
            Context:Items["state"]      := SELF:txtState:Text
            Context:Items["fullname"]   := SELF:txtfullname:Text
            Context:Items["addr"]       := SELF:txtAddress:Text
            Context:Items["addr2"]      := SELF:txtaddress2:Text
            Context:Items["cit"]        := SELF:txtcity:Text
            Context:Items["state"]      := SELF:txtState:Text
            Context:Items["postal"]     := SELF:txtzip:Text
            Context:Items["phone"]      := SELF:txtphone:Text
            Context:Items["eml"]        := SELF:txtemail:Text
            Context:Items["dogname"]    := SELF:txtdogname:Text
            Context:Items["dogage"]     := SELF:txtdogage:Text
            Context:Items["dogbreed"]   := SELF:txtdogbreed:Text
            Context:Items["eventid"]    := SELF:txtEventID:value
            // transfer control to the nextpage
            Server:Transfer("HerdingRegister-Validate.aspx")
        End If
    RETURN

END CLASS
CLASS frmHerdingRegisterValidate INHERIT frmEventLabels
CONSTRUCTOR()  
	SUPER()  	
    RETURN   
METHOD Page_Load(Sender AS OBJECT, e AS EventArgs) AS VOID    
    LOCAL cMsg      As String
    LOCAL connStr   As String
    LOCAL state     As String
    LOCAL country   As String
    LOCAL fullname  As String
    LOCAL addr      As String
    LOCAL addr2     As String
    LOCAL cit       As String
    LOCAL postal    As String
    LOCAL phone     As String
    LOCAL eml       As String
    LOCAL dogname   As String
    LOCAL dogage    As String
    LOCAL dogbreed  As String
    LOCAL ID        As String


    //get the variables as passed by the web site
    If !Page:IsPostBack
            connStr     := System.Configuration.ConfigurationManager.AppSettings["DSN"]
            
            country     := (string)context:items["country"]
            state       := (string)context:items["state"]
            fullname    := (string)context:items["fullname"]
            addr        := (string)context:items["addr"]
            addr2       := (string)context:items["addr2"]
            cit         := (string)context:items["cit"]
            postal      := (string)context:items["postal"]
            phone       := (string)context:items["phone"]
            eml         := (string)context:items["eml"]
            dogname     := (string)context:items["dogname"]
            dogage      := (string)context:items["dogage"]
            dogbreed    := (string)context:items["dogbreed"]
            ID          := (string)context:items["eventid"]

       
            // Assign the values to the textboxes
            SELF:txtfullname:Text      := fullname
            SELF:txtState:Text         := state
            SELF:txtaddress:Text       := addr
            SELF:txtaddress2:Text      := addr2
            SELF:txtcity:Text          := cit
            SELF:txtzip:Text           := postal
            SELF:CountryLabel:Text     := country
            SELF:txtcountry:Value      := country
            SELF:txtEventID:Value      := ID
            SELF:txtphone:Text         := phone
            SELF:txtemail:Text         := eml
            SELF:txtdogname:Text       := dogname
            SELF:txtdogage:Text        := dogage
            SELF:txtdogbreed:Text      := dogbreed
            SELF:msg:Text              := ""
            SELF:msg:Visible           := False
            SELF:Page:SetFocus(SELF:txtfullname)

            
            // set any message that may have been passed into the form
            cMsg := Request["msg"]
            If !empty(cMsg)
                SELF:msg:Text       := cMsg
                SELF:msg:Font:Size  := 14
                SELF:msg:ForeColor  := Drawing.Color.Red
                SELF:msg:Visible    := True
            End If    
    END IF

    SELF:HeadingMsg:Text := "Event Registration Form"
    RETURN
    
Protected Method btnSubmit_Click(sender As Object, e As System.EventArgs) AS VOID
        If Page:IsValid
            // set the variables that I will be passing to the next form
            Context:Items["country"]    := SELF:txtcountry:Value
            Context:Items["state"]      := SELF:txtState:Text
            Context:Items["fullname"]   := SELF:txtfullname:Text
            Context:Items["addr"]       := SELF:txtAddress:Text
            Context:Items["addr2"]      := SELF:txtaddress2:Text
            Context:Items["cit"]        := SELF:txtcity:Text
            Context:Items["state"]      := SELF:txtState:Text
            Context:Items["postal"]     := SELF:txtzip:Text
            Context:Items["phone"]      := SELF:txtphone:Text
            Context:Items["eml"]        := SELF:txtemail:Text
            Context:Items["dogname"]    := SELF:txtdogname:Text
            Context:Items["dogage"]     := SELF:txtdogage:Text
            Context:Items["dogbreed"]   := SELF:txtdogbreed:Text
            Context:Items["eventid"]    := SELF:txtEventID:Value
            // transfer control to the nextpage
            Server:Transfer("HerdingRegister-PaymentOptions.aspx")
        End If
    RETURN

END CLASS
CLASS frmHerdingRegisterPaymentOptions INHERIT frmEventBase
    PROTECT txtEventDate      As Label
    PROTECT cfullname         AS HiddenField
    PROTECT cState            AS HiddenField
    PROTECT caddress          AS HiddenField
    PROTECT caddress2         AS HiddenField
    PROTECT ccity             AS HiddenField
    PROTECT czip              AS HiddenField
    PROTECT ccountry          AS HiddenField
    PROTECT cEventID          AS HiddenField
    PROTECT cphone            AS HiddenField
    PROTECT cemail            AS HiddenField
    PROTECT cdogname          AS HiddenField
    PROTECT cdogage           AS HiddenField
    PROTECT cdogbreed         AS HiddenField

CONSTRUCTOR()  
	SUPER()  	
    RETURN   
METHOD Page_Load(Sender AS OBJECT, e AS EventArgs) AS VOID    
    LOCAL cMsg          As String
    LOCAL connStr       As String
    LOCAL oEvent        As MIMEvent
    LOCAL EventDate     As DateTime
    LOCAL nAmt          As Decimal
    LOCAL nCreditAmount As Decimal
    LOCAL state         As String
    LOCAL country       As String
    LOCAL fullname      As String
    LOCAL addr          As String
    LOCAL addr2         As String
    LOCAL cit           As String
    LOCAL postal        As String
    LOCAL phone         As String
    LOCAL eml           As String
    LOCAL dogname       As String
    LOCAL dogage        As String
    LOCAL dogbreed      As String
    LOCAL cID           As String
    LOCAL cUrl          As String
    LOCAL cReturn       As String
    LOCAL confNum       As String

      



    If !Page:IsPostBack
            connStr     := System.Configuration.ConfigurationManager.AppSettings["DSN"]
            //get the variables as passed by the web site
            country     := (string)context:items["country"]
            state       := (string)context:items["state"]
            fullname    := (string)context:items["fullname"]
            addr        := (string)context:items["addr"]
            addr2       := (string)context:items["addr2"]
            cit         := (string)context:items["cit"]
            postal      := (string)context:items["postal"]
            phone       := (string)context:items["phone"]
            eml         := (string)context:items["eml"]
            dogname     := (string)context:items["dogname"]
            dogage      := (string)context:items["dogage"]
            dogbreed    := (string)context:items["dogbreed"]
            cID         := (string)context:items["eventid"]            
            confNum     := ""
            
            //create the business object
            oEvent      := MIMEvent{}
            
            // put the user into the Pending database
            oEvent:ConnStr  := connStr
            oEvent:ID       := cID
            oEvent:FullName := fullname
            oEvent:Addr1    := addr
            oEvent:Addr2    := addr2
            oEvent:City     := cit
            oEvent:State    := state
            oEvent:Postal   := postal            
            oEvent:Phone    := phone
            oEvent:Email    := eml
            oEvent:DogName  := dogname
            oEvent:DogAge   := dogage
            oEvent:DogBreed := dogbreed
            nAmt            := 0
            EventDate       := DateTime{}
            
            // write the data out
            oEvent:WriteTempRegistration()
            oEvent:GetConfirmationNumber(confNum)
            oEvent:GetEventCost(nAmt, EventDate)

            SELF:txtEventDate:Text := EventDate:ToString("D")
            nCreditAmount := nAmt * (decimal)1.05

            
            // set the info onto the form       
            
            // Assign the values to the textboxes
            SELF:cfullname:Value      := fullname
            SELF:cState:Value         := state
            SELF:caddress:Value       := addr
            SELF:caddress2:Value      := addr2
            SELF:ccity:Value          := cit
            SELF:czip:Value           := postal
            SELF:ccountry:Value       := country
            SELF:cEventID:Value       := ID
            SELF:cphone:Value         := phone
            SELF:cemail:Value         := eml
            SELF:cdogname:Value       := dogname
            SELF:cdogage:Value        := dogage
            SELF:cdogbreed:Value      := dogbreed            
            SELF:msg:Text             := ""
            SELF:msg:Visible          := False
    END IF
    SELF:HeadingMsg:Text := "Event Registration Form"
    RETURN
    
Protected Method btnSubmit_Click(sender As Object, e As System.Web.UI.ImageClickEventArgs) AS VOID
        If Page:IsValid
            // set the variables that I will be passing to the next form
            Context:Items["country"]    := SELF:ccountry:Value
            Context:Items["state"]      := SELF:cState:Value
            Context:Items["fullname"]   := SELF:cfullname:Value
            Context:Items["addr"]       := SELF:cAddress:Value
            Context:Items["addr2"]      := SELF:caddress2:Value
            Context:Items["cit"]        := SELF:ccity:Value
            Context:Items["state"]      := SELF:cState:Value
            Context:Items["postal"]     := SELF:czip:Value
            Context:Items["phone"]      := SELF:cphone:Value
            Context:Items["eml"]        := SELF:cemail:Value
            Context:Items["dogname"]    := SELF:cdogname:Value
            Context:Items["dogage"]     := SELF:cdogage:Value
            Context:Items["dogbreed"]   := SELF:cdogbreed:Value
            Context:Items["eventid"]    := SELF:cEventID:value

            // transfer control to the nextpage
            Server:Transfer("HerdingRegister-Money_Order.aspx")
        End If
    RETURN
Protected METHOD Paypal_ServerClick(sender As Object, e As System.Web.UI.ImageClickEventArgs) aS VOID
//todo Fix this code once the page is working
/*
    LOCAL cUrl As String
    LOCAL cReturn As String
    If Page:IsValid
        Response:BufferOutput := True
        
        // build out cookie to keep track of the transaction
        Session("PayPal_redirected") := "true"
        Session("amt") = SELF:txtCreditAmount:Text
        Session("confnum") = SELF:txtConfNum:Value
        
        cReturn = "http://www.wmconsulting.com/mannersinmotion/HerdingRegister-After_Create.aspx"

        cUrl := "https://secure.paypal.com/cgi-bin/webscr"
        cUrl += "?cmd=_xclick"
        cUrl += "&business=" + "williem@wmconsulting.com"
        cUrl += "&item_name=" + "Herding Seminar with Wendy Roller"
        cUrl += "&item_number=" + "Herding101"
        //cUrl += "&amount=1.00"
        cUrl += "&amount=" + SELF:txtCreditAmount:Text
        cUrl += "&return=" + Server.HtmlEncode(cReturn)
        //Response:Write(cUrl)
        Response.Redirect(cUrl)
    End If
*/    
    RETURN
    

END CLASS

CLASS frmHerdingRegisterMoney_order INHERIT frmEventLabels
CONSTRUCTOR()  
	SUPER()  	
    RETURN   
METHOD Page_Load(Sender AS OBJECT, e AS EventArgs) AS VOID    
    LOCAL cMsg      As String
    LOCAL connStr   As String
    LOCAL state     As String
    LOCAL country   As String
    LOCAL fullname  As String
    LOCAL addr      As String
    LOCAL addr2     As String
    LOCAL cit       As String
    LOCAL postal    As String
    LOCAL phone     As String
    LOCAL eml       As String
    LOCAL dogname   As String
    LOCAL dogage    As String
    LOCAL dogbreed  As String
    LOCAL ID        As String


    //get the variables as passed by the web site
    If !Page:IsPostBack
            connStr     := System.Configuration.ConfigurationManager.AppSettings["DSN"]
            
            country     := (string)context:items["country"]
            state       := (string)context:items["state"]
            fullname    := (string)context:items["fullname"]
            addr        := (string)context:items["addr"]
            addr2       := (string)context:items["addr2"]
            cit         := (string)context:items["cit"]
            postal      := (string)context:items["postal"]
            phone       := (string)context:items["phone"]
            eml         := (string)context:items["eml"]
            dogname     := (string)context:items["dogname"]
            dogage      := (string)context:items["dogage"]
            dogbreed    := (string)context:items["dogbreed"]
            ID          := (string)context:items["eventid"]

       
            // Assign the values to the textboxes
            SELF:txtfullname:Text       := fullname
            SELF:txtState:Text          := state
            SELF:txtaddress:Text        := addr
            SELF:txtaddress2:Text       := addr2
            SELF:txtcity:Text           := cit
            SELF:txtzip:Text            := postal
            SELF:CountryLabel:Text      := country
            SELF:txtcountry:Value       := country
            SELF:txtEventID:Value       := ID
            SELF:txtphone:Text          := phone
            SELF:txtemail:Text          := eml
            SELF:txtdogname:Text        := dogname
            SELF:txtdogage:Text         := dogage
            SELF:txtdogbreed:Text       := dogbreed
            SELF:Page:SetFocus(SELF:txtfullname)            
    END IF

    RETURN
    
Protected Method btnSubmit_Click(sender As Object, e As System.EventArgs) AS VOID
        If Page:IsValid
            // transfer control to the nextpage
            Response:Redirect("HerdingRegister-After_create.aspx")
        End If
    RETURN

END CLASS
CLASS frmHerdingRegisterAfter_Create INHERIT frmEventBase
    PROTECT txtConFnum      As Label
    Protect fullname        AS Label
    PROTECT txtEventDate    As Label
CONSTRUCTOR()  
	SUPER()  	
    RETURN   
METHOD Page_Load(Sender AS OBJECT, e AS EventArgs) AS VOID    
    LOCAL connStr   As String
    LOCAL ID        As String
    LOCAL amt       As String
    LOCAL pmt       As String
    LOCAL confNum   As String
    LOCAL nAmt      As Decimal
    LOCAL oEvent    As MimEvent

    If !Page:IsPostBack 
        // get is out posted ivars
        // we will get the redst from the DB
        If Session["PayPal_redirected"] = "true" 
            pmt     := "PP"
            amt     := (string)Session["amt"]
            confnum := (string)Session["confnum"]
            Session:Remove("amt")
            Session:Remove("confnum")
            Session:Remove("PayPal_redirected")
        Else
            pmt     := Request["pmethod"]
            amt     := Request["amt"]
            confnum := Request["confNum"]
        End If
        nAmt := val(amt)
        
                
        // put the user into the database
        connStr         := System.Configuration.ConfigurationManager.AppSettings["DSN"]
        oEvent          := mimEvent{}
        oEvent:ConnStr  := connStr
        oEvent:Amt      := nAmt
        oEvent:Pmt      := pmt
        
        // write the user and send the emails
        oEvent:MoveConfNumIntoProduction(confnum)
        oEvent:sendEmails()
                  	        
        // update the form letter values so they show up on the screen corerectly
        SELF:txtConfNum:Text    := confnum
        SELF:fullname:Text      := oEvent:FullName
        SELF:txtEventDate:Text  := oEvent:EventDate:ToString("D")
        
    END IF

    SELF:HeadingMsg:Text := "Event Registration Form"
    RETURN
    
Protected Method btnSubmit_Click(sender As Object, e As System.EventArgs) AS VOID
    LOCAL cUrl As String
    cUrl = "HerdingRegister-After_Create.aspx?&confNum=" + Server:HtmlEncode(Me.txtConfNum.Value) & "&amt=" & Server.HtmlEncode(self:txtAmt:Value)
    cUrl += "&pmethod=" + Server:HtmlEncode(SELF:txtPmt:Value)
    If Page:IsValid
        Server.Transfer(cUrl)
    End If
    RETURN

END CLASS

Class frmBase Inherit Page
    PROTECT HeadingMsg          AS LABEL
    PROTECT msg                 AS LABEL
CONSTRUCTOR()
    SUPER()
    RETURN
End CLASS

CLASS frmEventBase INHERIT frmBase
    PROTECT txtfullname         AS TextBox
    PROTECT txtState            AS TextBox
    PROTECT txtaddress          AS TextBox
    PROTECT txtaddress2         AS TextBox
    PROTECT txtcity             AS TextBox
    PROTECT txtzip              AS TextBox
    PROTECT CountryLabel        AS Label
    PROTECT txtcountry          AS HiddenField
    PROTECT txtEventID          AS HiddenField
    PROTECT txtphone            AS TextBox
    PROTECT txtemail            AS TextBox
    PROTECT txtdogname          AS TextBox
    PROTECT txtdogage           AS TextBox
    PROTECT txtdogbreed         AS TextBox

CONSTRUCTOR()  
	SUPER()  	
    RETURN   
END CLASS

CLASS frmEventLabels INHERIT frmBase
    PROTECT txtfullname         AS Label
    PROTECT txtState            AS Label
    PROTECT txtaddress          AS Label
    PROTECT txtaddress2         AS Label
    PROTECT txtcity             AS Label
    PROTECT txtzip              AS Label
    PROTECT CountryLabel        AS Label
    PROTECT txtcountry          AS HiddenField
    PROTECT txtEventID          AS HiddenField
    PROTECT txtphone            AS Label
    PROTECT txtemail            AS Label
    PROTECT txtdogname          AS Label
    PROTECT txtdogage           AS Label
    PROTECT txtdogbreed         AS Label
CONSTRUCTOR()  
	SUPER()  	
    RETURN   
END CLASS