class IntegerTextBox inherit wmTextBox
    // Fields    
    private _maxValue := 2147483647 as int
    private _minValue := -2147483648 as int
    private _value as int

    // Methods
      virtual method Validate() as void
        super:IsValid := true
        if (self:Text:Trim() == "")
            if (.not. super:AllowBlank)
                super:ErrorMessage := String.Format(e"\''{0}\'' cannot be blank.", super:FriendlyName)
                super:IsValid := false
            endif
        else
            try
                self:_value := int32.Parse(self:Text)
                if (self:_value < self:MinValue)
                    super:ErrorMessage := String.Format(e"\''{0}\'' cannot be less than {1}", super:FriendlyName, self:MinValue)
                    super:IsValid := false
                endif
                if (self:_value > self:MaxValue)
                    super:ErrorMessage := String.Format(e"\''{0}\'' cannot be more than {1}", super:FriendlyName, self:MaxValue)
                    super:IsValid := false
                endif
            catch
                super:ErrorMessage := String.Format(e"\''{0}\'' is not a valid integer.", super:FriendlyName)
                super:IsValid := false
            end try
        endif

        return


    // Properties
    access MaxValue as int

    return self:_maxValue
    assign  MaxValue(value as int) as void

        local swap as int
        self:_maxValue := value
        if (self:_minValue > self:_maxValue)
            swap := self:_minValue
            self:_minValue := self:_maxValue
            self:_maxValue := swap
        endif

        return

    access MinValue as int

    return self:_minValue
    assign  MinValue(value as int) as void

        local swap as int
        self:_minValue := value
        if (self:_minValue > self:_maxValue)
            swap := self:_minValue
            self:_minValue := self:_maxValue
            self:_maxValue := swap
        endif

        return

    access Value as int

    return self:_value
    assign  Value(value as int) as void

        self:_value := value
        self:Text := self:_value:ToString()

        return


end class
