using System
using System.Drawing
using System.Web.UI.WebControls
using System.Web.UI

enum DisplayType
     Dynamic 
     None
     @@Static
end enum

class wmTextBox inherit System.Web.UI.WebControls.TextBox implements IValidator
    // Fields
    private _Display      := DisplayType.Dynamic as DisplayType
    private _blankAllowed := true                as logic
    private _errorMessage := ""                  as String
    private _friendlyName := ""                  as String
    private _valid        := true                as logic

    // Methods
    protected  virtual method OnInit(e as EventArgs) as void
        super:OnInit(e)
        self:Page:Validators:Add(self)

        return

    protected  virtual method OnUnload(e as EventArgs) as void
        if (self:Page <> null)
            self:Page:Validators:Remove(self)
        endif
        super:OnUnload(e)

        return
    
    protected  virtual method Render(output as HtmlTextWriter) as void
        local formattedMessage as String
        super:Render(output)
        if ((self:ErrorMessage <> null) .and. (self:ErrorMessage <> ""))
            formattedMessage := String.Concat(" ", self:ErrorMessage, "")
            do case
            case self:_Display == DisplayType.Static
                    output:Write(formattedMessage)
            case self:_Display == DisplayType.Dynamic
                 if (.not. self:IsValid)
                     output:Write(formattedMessage)
                 endif
            end case

         endif

         return
        

      virtual method Validate() as void
        self:IsValid := true
        if (.not. self:AllowBlank .and. (self:Text:Trim() == ""))
            self:ErrorMessage := String.Format(e"\''{0}\'' cannot be blank.", self:FriendlyName)
            self:IsValid := false
        endif

        return


    // Properties
    access AllowBlank as logic
        return self:_blankAllowed
        
    assign  AllowBlank(value as logic) as void
        self:_blankAllowed := value
        return

   access Display as DisplayType
        return self:_Display
   
   assign  Display(value as DisplayType) as void
                self:_Display := value
        return

    access FriendlyName as String
        return self:_friendlyName
    
    assign  FriendlyName(value as String) as void
        self:_friendlyName := value
        return

    // Virtal Properties
    virtual access ErrorMessage() as String
        return self:_errorMessage
        
    virtual assign  ErrorMessage(value as String) as void
        self:_errorMessage := value
        return

    virtual access IsValid() as Logic
        return self:_valid
        
    virtual assign  IsValid(value as logic) as void
        self:_valid := value
        if (.not. self:_valid)
            self:BackColor := Color.LightCoral
        else
            self:BackColor := Color.White
        endif

        return


end class

