<%@ Page Language="VB" ClassName="EventsMain" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.OLEDB" %>
<%@ Import Namespace="System.collections" %>

<script runat="server">
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs)
        If Not IsPostBack Then
            Me.EventsGrid.DataSource = FillGrid()
            Me.EventsGrid.DataBind()
        End If
    End Sub

    Sub Grid_Change(ByVal sender As Object, ByVal e As DataGridPageChangedEventArgs)
        Me.EventsGrid.CurrentPageIndex = e.NewPageIndex
        Me.EventsGrid.DataBind()
    End Sub 'Grid_Change
    
    Function FillGrid() As ICollection
        Dim connStr As String
        Dim conn As OleDbConnection
    
        Dim cSQL As String
        Dim adapter As New OleDbDataAdapter()
        Dim oDS As New DataSet()
        Dim title_col As New BoundColumn()
        Dim date_col As New BoundColumn()
        Dim loc_col As New BoundColumn()
        Dim description_col As New BoundColumn()
        Dim Cost_col As New BoundColumn()
        Dim Info_col As New ButtonColumn()

        ' put the user into the database
        connStr = System.Configuration.ConfigurationManager.AppSettings("DSN")
        conn = New OleDbConnection(connStr)
        conn.Open()
        
        cSQL = "select * from Events"
        cSQL = cSQL & " Order by EventDate Desc"

        adapter.SelectCommand = New OleDbCommand(cSQL, conn)
        adapter.Fill(oDS)

        ' Add out columns
        title_col.DataField = "EventTitle"
        title_col.HeaderText = "Event"
        Me.EventsGrid.Columns.Add(title_col)

        date_col.DataField = "EventDate"
        date_col.HeaderText = "Date"
        date_col.DataFormatString = "{0:MM-dd-yyyy}"
        Me.EventsGrid.Columns.Add(date_col)

        loc_col.DataField = "EventLocation"
        loc_col.HeaderText = "Loction"
        Me.EventsGrid.Columns.Add(loc_col)

        description_col.DataField = "EventDescription"
        description_col.HeaderText = "Description"
        description_col.ItemStyle.Width = 250
        description_col.ItemStyle.Wrap = "True"
        Me.EventsGrid.Columns.Add(description_col)

        Cost_col.DataField = "EventCost"
        Cost_col.HeaderText = "Cost"
        Cost_col.DataFormatString = "{0:c}"
        Me.EventsGrid.Columns.Add(Cost_col)

        Info_col.DataTextField = "EventOpen"
        Info_col.ButtonType = ButtonColumnType.LinkButton
        'Info_col.Text = "cancel"
        Info_col.CommandName = "cancel"
        Info_col.HeaderText = " "
        Me.EventsGrid.Columns.Add(Info_col)
        
        Return oDS.Tables(0).DefaultView

    End Function 'FillGrid

    Sub Item_Bound(ByVal sender As Object, ByVal e As DataGridItemEventArgs)
        Dim item As DataGridItem
        Dim rv As DataRowView
        Dim b As New HyperLink
        Dim cUrl As String
        Dim cEventID As String
        Dim EventDate As Date
        
        item = e.Item
        If item.ItemType = ListItemType.AlternatingItem Or item.ItemType = ListItemType.Item Then
            rv = item.DataItem
            If rv.Row.Item("EventOpen") = False Then
                item.Cells(5).Visible = False
                'item.Visible = False
            Else
                cEventID = rv.Row.Item("EventID")
                EventDate = rv.Row.Item("EventDate")
                cUrl = rv.Row.Item("EventUrl") & ".aspx?EventID=" & cEventID & "&EventDate=" & Server.HtmlEncode(EventDate.ToString("D"))
                cUrl = cUrl & "&EventLoc=" & Server.HtmlEncode(rv.Row.Item("EventLocation"))
                cUrl = cUrl & "&EventCost=" & Server.HtmlEncode(rv.Row.Item("EventCost"))
                cUrl = cUrl & "&Eventtime=" & Server.HtmlEncode(rv.Row.Item("EventStartTime"))
                b.ID = "BtnClick"
                b.Text = "Open"
                b.NavigateUrl = cUrl
                b.Enabled = True
                item.Cells(5).Controls.RemoveAt(0)
                item.Cells(5).Controls.Add(b)
            End If
        End If

    End Sub 'Item_Bound 

</script>

<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
        <meta http-equiv="Content-Type" content="text/html; charset=windows-1252" />
        <meta http-equiv="Content-Language" content="en-us" />
        <meta name="keywords" content="flyball, dogs, birmingham, alabama, team, bandits, agility, obedience, tracking, herding, daycare" />
        <meta name="description" content="Manners in Motion utilized the click and treat method of training " />
        <meta name="robots" content="FOLLOW,INDEX" />
        <title>Manners In Motion</title>
        <link href="/mannersinmotion/include/mim.css" rel="stylesheet" title="styles" type="text/css" />
	</head>
	<body>
		<table width="100%" cellspacing="0" cellpadding="0" border="0" runat="server">
			<tr>
				<td width="97%" align="left" valign="top">
				    <p align="center">
    				    <a href="http://www.mannersinmotion.com" target="blank"><asp:image id="Logo" ImageUrl="/mannersinmotion/pictures/web%20dog%20with%20bouncing%20ball.jpg" class="logo" runat="server" ImageAlign="Top" /></a>    				    <br /> <br />   				
					    <font size="5"><b>  Upcoming Events at Manners in Motion</b></font>
                    </p>

                   <form id="Form1" method="post" runat="server" style="text-align: center">
                        <asp:datagrid id="EventsGrid" OnItemDataBound="item_bound" runat="server" OnPageIndexChanged="Grid_Change" PageSize="15" BorderWidth="4px" BorderStyle="Double" ForeColor="Black" AutoGenerateColumns="False" CellPadding="10" AllowPaging="True">
                            <HeaderStyle font-underline="True" font-bold="True" backcolor="#FFFF66"></HeaderStyle>
                            <PagerStyle borderwidth="4px" borderstyle="Solid" mode="NumericPages"></PagerStyle>                            
                        </asp:datagrid>
                       &nbsp;&nbsp; &nbsp;</form>
                   
					
					<div align="center">
		                <font size="2"><a href="javascript:history.back()">Return to Previous Page</a></font>	
		    		    <br /><br />
		    		    <hr style="width: 85%;" />
    					<font size="1">Last Updated: September 13th, 2007<br /></font>
	    			</div>
	    			
	            </td>
	        </tr>
		</table>
    <!--#include virtual="/mannersinmotion/include/sys-footer.inc" -->
		
	</body>
</html>